﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.TradeRules
{
    [StorableClass]
    [Item("ConstantInt", "Represents a ConstantInt value.")]
    public sealed class ConstantInt : Symbol
    {
        private const int minimumArity = 0;
        private const int maximumArity = 0;

        public override int MinimumArity
        {
            get { return minimumArity; }
        }
        public override int MaximumArity
        {
            get { return maximumArity; }
        }


        [StorableConstructor]
        private ConstantInt(bool deserializing) : base(deserializing) { }
        private ConstantInt(ConstantInt original, Cloner cloner)
            : base(original, cloner)
        {
        }
        public ConstantInt()
            : base("ConstantInt", "Represents a ConstantInt value.")
        {
        }

        public override ISymbolicExpressionTreeNode CreateTreeNode()
        {
            return new ConstantIntTreeNode(this);
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new ConstantInt(this, cloner);
        }
    }
}
